#
# Conditional build:
%bcond_without	kernelsrc	# probes which require full kernel source (kvm, btrfs, ext4, regmap)
%bcond_with	verbose		# verbose build (V=1)

# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0

%define		rel	2
%define		pname	lttng-modules
Summary:	LTTng 2.x kernel modules
Summary(pl.UTF-8):	Moduły jądra LTTng 2.x
Name:		%{pname}%{_alt_kernel}
Version:	2.13.7
Release:	%{rel}@%{_kernel_ver_str}
License:	GPL v2
Group:		Base/Kernel
Source0:	https://lttng.org/files/lttng-modules/%{pname}-%{version}.tar.bz2
# Source0-md5:	fe95650bcb5d718e794b9cc8df794904
Patch0:		build.patch
Patch1:		kernel-6.1.patch
URL:		https://lttng.org/
%{expand:%buildrequires_kernel kernel%%{_alt_kernel}-module-build >= 3:3.0}
%{?with_kernelsrc:%{expand:%buildrequires_kernel kernel%%{_alt_kernel}-source >= 3:3.0}}
BuildRequires:	rpmbuild(macros) >= 1.746
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
LTTng 2.x kernel modules.

%description -l pl.UTF-8
Moduły jądra LTTng 2.x.

%define	kernel_pkg()\
%package -n kernel%{_alt_kernel}-lttng\
Summary:	LTTng 2.x modules for Linux kernel\
Summary(pl.UTF-8):	Moduły LTTng 2.x dla jądra Linuksa\
Release:	%{rel}@%{_kernel_ver_str}\
Group:		Base/Kernel\
Requires(post,postun):	/sbin/depmod\
%requires_releq_kernel\
Requires(postun):	%releq_kernel\
\
%description -n kernel%{_alt_kernel}-lttng\
LTTng 2.x modules for Linux kernel.\
\
%description -n kernel%{_alt_kernel}-lttng -l pl.UTF-8\
Moduły LTTng 2.x dla jądra Linuksa.\
\
%files -n kernel%{_alt_kernel}-lttng\
%defattr(644,root,root,755)\
%doc %{pname}-%{version}/{ChangeLog,LICENSE,README.md}\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-clock.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-counter-client-percpu-32-modular.ko.*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-counter-client-percpu-64-modular.ko.*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-ring-buffer-*.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-statedump.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-tracer.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lttng-wrapper.ko*\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng/lib\
/lib/modules/%{_kernel_ver}/kernel/lttng/lib/lttng-counter.ko.*\
/lib/modules/%{_kernel_ver}/kernel/lttng/lib/lttng-lib-ring-buffer.ko*\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng/probes\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-kprobes.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-kretprobes.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-probe-*.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/probes/lttng-uprobes.ko*\
%dir /lib/modules/%{_kernel_ver}/kernel/lttng/tests\
/lib/modules/%{_kernel_ver}/kernel/lttng/tests/lttng-clock-plugin-test.ko*\
/lib/modules/%{_kernel_ver}/kernel/lttng/tests/lttng-test.ko*\
\
%post	-n kernel%{_alt_kernel}-lttng\
%depmod %{_kernel_ver}\
\
%postun	-n kernel%{_alt_kernel}-lttng\
%depmod %{_kernel_ver}\
%{nil}

%define build_kernel_pkg()\
%{__make} clean \\\
	KERNELDIR=%{_kernelsrcdir}\
%{__make} \\\
	KERNELDIR=%{_kernelsrcdir}\
p=`pwd`\
%{__make} modules_install \\\
	INSTALL_MOD_PATH=$p/../installed \\\
	INSTALL_MOD_DIR=kernel/lttng \\\
	KERNELDIR=%{_kernelsrcdir}\
%{nil}

%{expand:%create_kernel_packages}

%prep
%setup -qc -n %{name}-%{version}
cd %{pname}-%{version}
%patch0 -p1
%patch1 -p1

%build
cd  %{pname}-%{version}
%{expand:%build_kernel_packages}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT

cp -a installed/* $RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT
%changelog
* Fri Dec 23 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/lttng-modules.git;a=log;h=auto/th/lttng-modules-2.13.7-2

* Sun Dec 18 2022 Jan Rękorajski <baggins@pld-linux.org> 20f9ec3
- rel 2

* Sat Dec 17 2022 Jan Rękorajski <baggins@pld-linux.org> 9397200
- upstream fix for building with kernel 6.1

* Fri Oct 28 2022 Jan Rękorajski <baggins@pld-linux.org> cdb8ee3
- up to 2.13.7

* Sun Aug 28 2022 Jan Rękorajski <baggins@pld-linux.org> 695e001
- kernel 5.10 compatibility fix, rel 3

* Sat Aug 13 2022 Jan Rękorajski <baggins@pld-linux.org> ba894a6
- upstream fixes for kernel 5.19, rel 2

* Thu Jun 16 2022 Jan Rękorajski <baggins@pld-linux.org> 3496d32
- up to 2.13.4

* Wed May 25 2022 Jan Rękorajski <baggins@pld-linux.org> 5041df6
- upstream fixes for kernel 5.18 compatibility, rel 2

* Sat Apr 02 2022 Jan Rękorajski <baggins@pld-linux.org> 812c8d8
- up to 2.13.3

* Sat Jan 15 2022 Jan Rękorajski <baggins@pld-linux.org> 5ef7e51
- up to 2.13.1

* Sun Nov 07 2021 Jan Rękorajski <baggins@pld-linux.org> 84fe1df
- upstream fix for kernel 5.15, rel 4

* Tue Sep 07 2021 Jan Rękorajski <baggins@pld-linux.org> 1d12a08
- up to 2.13.0 final

* Sun Jul 04 2021 Jan Rękorajski <baggins@pld-linux.org> 4b0bc27
- up to 2.13.0 rc2, rel 2

* Mon May 03 2021 Jan Rękorajski <baggins@pld-linux.org> 417a627
- up to 2.13.0-rc1

* Wed Feb 24 2021 Jan Rękorajski <baggins@pld-linux.org> 783d54c
- up to 2.12.5

* Sat Feb 06 2021 Jan Rękorajski <baggins@pld-linux.org> abf0d8a
- fix building with kernel 4.9.256
- rel 2

* Sat Nov 28 2020 Jan Rękorajski <baggins@pld-linux.org> b704ebb
- up to 2.2.13 + latest fixes

* Sat Sep 26 2020 Jan Rękorajski <baggins@pld-linux.org> f9dfa75
- add fixes from upstream git with fixes to build modules on recent kernels
- rel 2

* Sun Aug 16 2020 Jan Rękorajski <baggins@pld-linux.org> aa9cd3d
- up to 2.12.2

* Fri Jun 05 2020 Jan Rękorajski <baggins@pld-linux.org> 10babb8
- up to 2.12.1

* Tue Apr 14 2020 Jakub Bogusz <qboosh@pld-linux.org> 9a3ded0
- updated to 2.12.0 (for Linux 3.0+; ftrace integration dropped)
- removed obsolete kernel-5.5.3 patch

